# autogenerated by genmsg_py from GetStateValidityRequest.msg. Do not edit.
import roslib.message
import struct

import roslib.msg
import motion_planning_msgs.msg
import geometric_shapes_msgs.msg
import geometry_msgs.msg
import sensor_msgs.msg
import roslib.rostime

class GetStateValidityRequest(roslib.message.Message):
  _md5sum = "2fcf13a08ce27c11ce143e366c07e133"
  _type = "planning_environment_msgs/GetStateValidityRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """

motion_planning_msgs/RobotState robot_state


bool check_collisions


bool check_path_constraints


bool check_goal_constraints


bool check_joint_limits




motion_planning_msgs/OrderedCollisionOperations ordered_collision_operations



motion_planning_msgs/AllowedContactSpecification[] allowed_contacts




motion_planning_msgs/Constraints path_constraints




motion_planning_msgs/Constraints goal_constraints


================================================================================
MSG: motion_planning_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state
motion_planning_msgs/MultiDOFJointState multi_dof_joint_state
================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint is defined by:
#  * the position of the joint, 
#  * the velocity of the joint and 
#  * the effort that is applied in the joint.
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: roslib/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: motion_planning_msgs/MultiDOFJointState
#A representation of a multi-dof joint state
time stamp
string joint_name
string frame_id
string child_frame_id
geometry_msgs/Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: motion_planning_msgs/OrderedCollisionOperations
# A set of collision operations that will be performed in the order they are specified
CollisionOperation[] collision_operations
================================================================================
MSG: motion_planning_msgs/CollisionOperation
# A definition of a collision operation
# E.g. ("gripper",COLLISION_SET_ALL,ENABLE) will enable collisions 
# between the gripper and all objects in the collision space

string object1
string object2
string COLLISION_SET_ALL="all"
string COLLISION_SET_OBJECTS="objects"
string COLLISION_SET_ATTACHED_OBJECTS="attached"

# The penetration distance to which collisions are allowed. This is 0.0 by default.
float64 penetration_distance

# Flag that determines whether collisions will be enabled or disabled for the pair of objects specified above
int32 operation
int32 DISABLE=0
int32 ENABLE=1

================================================================================
MSG: motion_planning_msgs/AllowedContactSpecification
# The names of the regions
string name

# The shape of the region in the environment
geometric_shapes_msgs/Shape shape

# The pose of the space defining the region
geometry_msgs/PoseStamped pose_stamped

# The set of links that will be allowed to have penetration contact within this region
string[] link_names

# The maximum penetration depth allowed for every link
float64 penetration_depth
================================================================================
MSG: geometric_shapes_msgs/Shape
byte SPHERE=0
byte BOX=1
byte CYLINDER=2
byte MESH=3

byte type


#### define sphere, box, cylinder ####
# the origin of each shape is considered at the shape's center

# for sphere
# radius := dimensions[0]

# for cylinder
# radius := dimensions[0]
# length := dimensions[1]
# the length is along the Z axis

# for box
# size_x := dimensions[0]
# size_y := dimensions[1]
# size_z := dimensions[2]
float64[] dimensions


#### define mesh ####

# list of triangles; triangle k is defined by tre vertices located
# at indices triangles[3k], triangles[3k+1], triangles[3k+2]
int32[] triangles
geometry_msgs/Point[] vertices

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: motion_planning_msgs/Constraints
# This message contains a list of motion planning constraints.

motion_planning_msgs/JointConstraint[] joint_constraints
motion_planning_msgs/PositionConstraint[] position_constraints
motion_planning_msgs/OrientationConstraint[] orientation_constraints

================================================================================
MSG: motion_planning_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/PositionConstraint
# This message contains the definition of a position constraint.
Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Point target_point_offset

# The nominal/target position for the point we are planning for
geometry_msgs/Point position

# The shape of the bounded region that constrains the position of the end-effector
# This region is always centered at the position defined above
geometric_shapes_msgs/Shape constraint_region_shape

# The orientation of the bounded region that constrains the position of the end-effector. 
# This allows the specification of non-axis aligned constraints
geometry_msgs/Quaternion constraint_region_orientation

# Constraint weighting factor - a weight for this constraint
float64 weight
================================================================================
MSG: motion_planning_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.
Header header

# The robot link this constraint refers to
string link_name

# The type of the constraint
int32 type
int32 LINK_FRAME=0
int32 HEADER_FRAME=1

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# optional RPY error tolerances specified if 
float64 absolute_roll_tolerance
float64 absolute_pitch_tolerance
float64 absolute_yaw_tolerance

# Constraint weighting factor - a weight for this constraint
float64 weight

"""
  __slots__ = ['robot_state','check_collisions','check_path_constraints','check_goal_constraints','check_joint_limits','ordered_collision_operations','allowed_contacts','path_constraints','goal_constraints']
  _slot_types = ['motion_planning_msgs/RobotState','bool','bool','bool','bool','motion_planning_msgs/OrderedCollisionOperations','motion_planning_msgs/AllowedContactSpecification[]','motion_planning_msgs/Constraints','motion_planning_msgs/Constraints']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   robot_state,check_collisions,check_path_constraints,check_goal_constraints,check_joint_limits,ordered_collision_operations,allowed_contacts,path_constraints,goal_constraints
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetStateValidityRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.robot_state is None:
        self.robot_state = motion_planning_msgs.msg.RobotState()
      if self.check_collisions is None:
        self.check_collisions = False
      if self.check_path_constraints is None:
        self.check_path_constraints = False
      if self.check_goal_constraints is None:
        self.check_goal_constraints = False
      if self.check_joint_limits is None:
        self.check_joint_limits = False
      if self.ordered_collision_operations is None:
        self.ordered_collision_operations = motion_planning_msgs.msg.OrderedCollisionOperations()
      if self.allowed_contacts is None:
        self.allowed_contacts = []
      if self.path_constraints is None:
        self.path_constraints = motion_planning_msgs.msg.Constraints()
      if self.goal_constraints is None:
        self.goal_constraints = motion_planning_msgs.msg.Constraints()
    else:
      self.robot_state = motion_planning_msgs.msg.RobotState()
      self.check_collisions = False
      self.check_path_constraints = False
      self.check_goal_constraints = False
      self.check_joint_limits = False
      self.ordered_collision_operations = motion_planning_msgs.msg.OrderedCollisionOperations()
      self.allowed_contacts = []
      self.path_constraints = motion_planning_msgs.msg.Constraints()
      self.goal_constraints = motion_planning_msgs.msg.Constraints()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<3I', self.robot_state.joint_state.header.seq, self.robot_state.joint_state.header.stamp.secs, self.robot_state.joint_state.header.stamp.nsecs))
      length = len(self.robot_state.joint_state.header.frame_id)
      #serialize self.robot_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.joint_state.header.frame_id))
      #serialize self.robot_state.joint_state.name
      length = len(self.robot_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.robot_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.robot_state.joint_state.position
      length = len(self.robot_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.robot_state.joint_state.position))
      #serialize self.robot_state.joint_state.velocity
      length = len(self.robot_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.robot_state.joint_state.velocity))
      #serialize self.robot_state.joint_state.effort
      length = len(self.robot_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(struct.pack(pattern, *self.robot_state.joint_state.effort))
      buff.write(struct.pack('<2I', self.robot_state.multi_dof_joint_state.stamp.secs, self.robot_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.robot_state.multi_dof_joint_state.joint_name)
      #serialize self.robot_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.joint_name))
      length = len(self.robot_state.multi_dof_joint_state.frame_id)
      #serialize self.robot_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.frame_id))
      length = len(self.robot_state.multi_dof_joint_state.child_frame_id)
      #serialize self.robot_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d4B', self.robot_state.multi_dof_joint_state.pose.position.x, self.robot_state.multi_dof_joint_state.pose.position.y, self.robot_state.multi_dof_joint_state.pose.position.z, self.robot_state.multi_dof_joint_state.pose.orientation.x, self.robot_state.multi_dof_joint_state.pose.orientation.y, self.robot_state.multi_dof_joint_state.pose.orientation.z, self.robot_state.multi_dof_joint_state.pose.orientation.w, self.check_collisions, self.check_path_constraints, self.check_goal_constraints, self.check_joint_limits))
      #serialize self.ordered_collision_operations.collision_operations
      length = len(self.ordered_collision_operations.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.ordered_collision_operations.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
      #serialize self.allowed_contacts
      length = len(self.allowed_contacts)
      buff.write(struct.pack('<I', length))
      for val1 in self.allowed_contacts:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<b', val1.shape.type))
        #serialize val1.shape.dimensions
        length = len(val1.shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.shape.dimensions))
        #serialize val1.shape.triangles
        length = len(val1.shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.shape.triangles))
        #serialize val1.shape.vertices
        length = len(val1.shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<I', val1.pose_stamped.header.seq))
        buff.write(struct.pack('<2I', val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs))
        length = len(val1.pose_stamped.header.frame_id)
        #serialize val1.pose_stamped.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.pose_stamped.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w))
        #serialize val1.link_names
        length = len(val1.link_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.link_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(struct.pack('<d', val1.penetration_depth))
      #serialize self.path_constraints.joint_constraints
      length = len(self.path_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.path_constraints.position_constraints
      length = len(self.path_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.path_constraints.orientation_constraints
      length = len(self.path_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.goal_constraints.joint_constraints
      length = len(self.goal_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.goal_constraints.position_constraints
      length = len(self.goal_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.dimensions))
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(struct.pack(pattern, *val1.constraint_region_shape.triangles))
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.goal_constraints.orientation_constraints
      length = len(self.goal_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.robot_state is None:
        self.robot_state = motion_planning_msgs.msg.RobotState()
      if self.ordered_collision_operations is None:
        self.ordered_collision_operations = motion_planning_msgs.msg.OrderedCollisionOperations()
      if self.path_constraints is None:
        self.path_constraints = motion_planning_msgs.msg.Constraints()
      if self.goal_constraints is None:
        self.goal_constraints = motion_planning_msgs.msg.Constraints()
      end = 0
      start = end
      end += 12
      (self.robot_state.joint_state.header.seq, self.robot_state.joint_state.header.stamp.secs, self.robot_state.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.robot_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.robot_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.robot_state.joint_state.name.append(val1)
      #deserialize self.robot_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.position = struct.unpack(pattern, str[start:end])
      #deserialize self.robot_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.velocity = struct.unpack(pattern, str[start:end])
      #deserialize self.robot_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.effort = struct.unpack(pattern, str[start:end])
      start = end
      end += 8
      (self.robot_state.multi_dof_joint_state.stamp.secs, self.robot_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 60
      (self.robot_state.multi_dof_joint_state.pose.position.x, self.robot_state.multi_dof_joint_state.pose.position.y, self.robot_state.multi_dof_joint_state.pose.position.z, self.robot_state.multi_dof_joint_state.pose.orientation.x, self.robot_state.multi_dof_joint_state.pose.orientation.y, self.robot_state.multi_dof_joint_state.pose.orientation.z, self.robot_state.multi_dof_joint_state.pose.orientation.w, self.check_collisions, self.check_path_constraints, self.check_goal_constraints, self.check_joint_limits,) = struct.unpack('<7d4B',str[start:end])
      self.check_collisions = bool(self.check_collisions)
      self.check_path_constraints = bool(self.check_path_constraints)
      self.check_goal_constraints = bool(self.check_goal_constraints)
      self.check_joint_limits = bool(self.check_joint_limits)
      #deserialize self.ordered_collision_operations.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.ordered_collision_operations.collision_operations.append(val1)
      #deserialize self.allowed_contacts
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 1
        (val1.shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.shape.vertices.append(val3)
        start = end
        end += 4
        (val1.pose_stamped.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.pose_stamped.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        #deserialize val1.link_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = struct.unpack('<d',str[start:end])
        self.allowed_contacts.append(val1)
      #deserialize self.path_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.path_constraints.joint_constraints.append(val1)
      #deserialize self.path_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.path_constraints.position_constraints.append(val1)
      #deserialize self.path_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.path_constraints.orientation_constraints.append(val1)
      #deserialize self.goal_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.goal_constraints.joint_constraints.append(val1)
      #deserialize self.goal_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = struct.unpack(pattern, str[start:end])
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.goal_constraints.position_constraints.append(val1)
      #deserialize self.goal_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.goal_constraints.orientation_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<3I', self.robot_state.joint_state.header.seq, self.robot_state.joint_state.header.stamp.secs, self.robot_state.joint_state.header.stamp.nsecs))
      length = len(self.robot_state.joint_state.header.frame_id)
      #serialize self.robot_state.joint_state.header.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.joint_state.header.frame_id))
      #serialize self.robot_state.joint_state.name
      length = len(self.robot_state.joint_state.name)
      buff.write(struct.pack('<I', length))
      for val1 in self.robot_state.joint_state.name:
        length = len(val1)
        #serialize val1
        buff.write(struct.pack('<I%ss'%length, length, val1))
      #serialize self.robot_state.joint_state.position
      length = len(self.robot_state.joint_state.position)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.robot_state.joint_state.position.tostring())
      #serialize self.robot_state.joint_state.velocity
      length = len(self.robot_state.joint_state.velocity)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.robot_state.joint_state.velocity.tostring())
      #serialize self.robot_state.joint_state.effort
      length = len(self.robot_state.joint_state.effort)
      buff.write(struct.pack('<I', length))
      pattern = '<%sd'%length
      buff.write(self.robot_state.joint_state.effort.tostring())
      buff.write(struct.pack('<2I', self.robot_state.multi_dof_joint_state.stamp.secs, self.robot_state.multi_dof_joint_state.stamp.nsecs))
      length = len(self.robot_state.multi_dof_joint_state.joint_name)
      #serialize self.robot_state.multi_dof_joint_state.joint_name
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.joint_name))
      length = len(self.robot_state.multi_dof_joint_state.frame_id)
      #serialize self.robot_state.multi_dof_joint_state.frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.frame_id))
      length = len(self.robot_state.multi_dof_joint_state.child_frame_id)
      #serialize self.robot_state.multi_dof_joint_state.child_frame_id
      buff.write(struct.pack('<I%ss'%length, length, self.robot_state.multi_dof_joint_state.child_frame_id))
      buff.write(struct.pack('<7d4B', self.robot_state.multi_dof_joint_state.pose.position.x, self.robot_state.multi_dof_joint_state.pose.position.y, self.robot_state.multi_dof_joint_state.pose.position.z, self.robot_state.multi_dof_joint_state.pose.orientation.x, self.robot_state.multi_dof_joint_state.pose.orientation.y, self.robot_state.multi_dof_joint_state.pose.orientation.z, self.robot_state.multi_dof_joint_state.pose.orientation.w, self.check_collisions, self.check_path_constraints, self.check_goal_constraints, self.check_joint_limits))
      #serialize self.ordered_collision_operations.collision_operations
      length = len(self.ordered_collision_operations.collision_operations)
      buff.write(struct.pack('<I', length))
      for val1 in self.ordered_collision_operations.collision_operations:
        length = len(val1.object1)
        #serialize val1.object1
        buff.write(struct.pack('<I%ss'%length, length, val1.object1))
        length = len(val1.object2)
        #serialize val1.object2
        buff.write(struct.pack('<I%ss'%length, length, val1.object2))
        buff.write(struct.pack('<di', val1.penetration_distance, val1.operation))
      #serialize self.allowed_contacts
      length = len(self.allowed_contacts)
      buff.write(struct.pack('<I', length))
      for val1 in self.allowed_contacts:
        length = len(val1.name)
        #serialize val1.name
        buff.write(struct.pack('<I%ss'%length, length, val1.name))
        buff.write(struct.pack('<b', val1.shape.type))
        #serialize val1.shape.dimensions
        length = len(val1.shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.shape.dimensions.tostring())
        #serialize val1.shape.triangles
        length = len(val1.shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.shape.triangles.tostring())
        #serialize val1.shape.vertices
        length = len(val1.shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<I', val1.pose_stamped.header.seq))
        buff.write(struct.pack('<2I', val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs))
        length = len(val1.pose_stamped.header.frame_id)
        #serialize val1.pose_stamped.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.pose_stamped.header.frame_id))
        buff.write(struct.pack('<3d', val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z))
        buff.write(struct.pack('<4d', val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w))
        #serialize val1.link_names
        length = len(val1.link_names)
        buff.write(struct.pack('<I', length))
        for val2 in val1.link_names:
          length = len(val2)
          #serialize val2
          buff.write(struct.pack('<I%ss'%length, length, val2))
        buff.write(struct.pack('<d', val1.penetration_depth))
      #serialize self.path_constraints.joint_constraints
      length = len(self.path_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.path_constraints.position_constraints
      length = len(self.path_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.path_constraints.orientation_constraints
      length = len(self.path_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.path_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
      #serialize self.goal_constraints.joint_constraints
      length = len(self.goal_constraints.joint_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.joint_constraints:
        length = len(val1.joint_name)
        #serialize val1.joint_name
        buff.write(struct.pack('<I%ss'%length, length, val1.joint_name))
        buff.write(struct.pack('<4d', val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight))
      #serialize self.goal_constraints.position_constraints
      length = len(self.goal_constraints.position_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.position_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<3d', val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z))
        buff.write(struct.pack('<3d', val1.position.x, val1.position.y, val1.position.z))
        buff.write(struct.pack('<b', val1.constraint_region_shape.type))
        #serialize val1.constraint_region_shape.dimensions
        length = len(val1.constraint_region_shape.dimensions)
        buff.write(struct.pack('<I', length))
        pattern = '<%sd'%length
        buff.write(val1.constraint_region_shape.dimensions.tostring())
        #serialize val1.constraint_region_shape.triangles
        length = len(val1.constraint_region_shape.triangles)
        buff.write(struct.pack('<I', length))
        pattern = '<%si'%length
        buff.write(val1.constraint_region_shape.triangles.tostring())
        #serialize val1.constraint_region_shape.vertices
        length = len(val1.constraint_region_shape.vertices)
        buff.write(struct.pack('<I', length))
        for val3 in val1.constraint_region_shape.vertices:
          buff.write(struct.pack('<3d', val3.x, val3.y, val3.z))
        buff.write(struct.pack('<4d', val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w))
        buff.write(struct.pack('<d', val1.weight))
      #serialize self.goal_constraints.orientation_constraints
      length = len(self.goal_constraints.orientation_constraints)
      buff.write(struct.pack('<I', length))
      for val1 in self.goal_constraints.orientation_constraints:
        buff.write(struct.pack('<I', val1.header.seq))
        buff.write(struct.pack('<2I', val1.header.stamp.secs, val1.header.stamp.nsecs))
        length = len(val1.header.frame_id)
        #serialize val1.header.frame_id
        buff.write(struct.pack('<I%ss'%length, length, val1.header.frame_id))
        length = len(val1.link_name)
        #serialize val1.link_name
        buff.write(struct.pack('<I%ss'%length, length, val1.link_name))
        buff.write(struct.pack('<i', val1.type))
        buff.write(struct.pack('<4d', val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w))
        buff.write(struct.pack('<4d', val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.robot_state is None:
        self.robot_state = motion_planning_msgs.msg.RobotState()
      if self.ordered_collision_operations is None:
        self.ordered_collision_operations = motion_planning_msgs.msg.OrderedCollisionOperations()
      if self.path_constraints is None:
        self.path_constraints = motion_planning_msgs.msg.Constraints()
      if self.goal_constraints is None:
        self.goal_constraints = motion_planning_msgs.msg.Constraints()
      end = 0
      start = end
      end += 12
      (self.robot_state.joint_state.header.seq, self.robot_state.joint_state.header.stamp.secs, self.robot_state.joint_state.header.stamp.nsecs,) = struct.unpack('<3I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.joint_state.header.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.joint_state.header.frame_id,) = struct.unpack(pattern, str[start:end])
      #deserialize self.robot_state.joint_state.name
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.robot_state.joint_state.name = []
      for i in xrange(0, length):
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1,) = struct.unpack(pattern, str[start:end])
        self.robot_state.joint_state.name.append(val1)
      #deserialize self.robot_state.joint_state.position
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.robot_state.joint_state.velocity
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      #deserialize self.robot_state.joint_state.effort
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      pattern = '<%sd'%length
      start = end
      end += struct.calcsize(pattern)
      self.robot_state.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.robot_state.multi_dof_joint_state.stamp.secs, self.robot_state.multi_dof_joint_state.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.joint_name
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.joint_name,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      #deserialize self.robot_state.multi_dof_joint_state.child_frame_id
      pattern = '<%ss'%length
      start = end
      end += struct.calcsize(pattern)
      (self.robot_state.multi_dof_joint_state.child_frame_id,) = struct.unpack(pattern, str[start:end])
      start = end
      end += 60
      (self.robot_state.multi_dof_joint_state.pose.position.x, self.robot_state.multi_dof_joint_state.pose.position.y, self.robot_state.multi_dof_joint_state.pose.position.z, self.robot_state.multi_dof_joint_state.pose.orientation.x, self.robot_state.multi_dof_joint_state.pose.orientation.y, self.robot_state.multi_dof_joint_state.pose.orientation.z, self.robot_state.multi_dof_joint_state.pose.orientation.w, self.check_collisions, self.check_path_constraints, self.check_goal_constraints, self.check_joint_limits,) = struct.unpack('<7d4B',str[start:end])
      self.check_collisions = bool(self.check_collisions)
      self.check_path_constraints = bool(self.check_path_constraints)
      self.check_goal_constraints = bool(self.check_goal_constraints)
      self.check_joint_limits = bool(self.check_joint_limits)
      #deserialize self.ordered_collision_operations.collision_operations
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.ordered_collision_operations.collision_operations = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.CollisionOperation()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object1
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object1,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.object2
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.object2,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 12
        (val1.penetration_distance, val1.operation,) = struct.unpack('<di',str[start:end])
        self.ordered_collision_operations.collision_operations.append(val1)
      #deserialize self.allowed_contacts
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.allowed_contacts = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.AllowedContactSpecification()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 1
        (val1.shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.shape.vertices.append(val3)
        start = end
        end += 4
        (val1.pose_stamped.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.pose_stamped.header.stamp.secs, val1.pose_stamped.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.pose_stamped.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.pose_stamped.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.pose_stamped.pose.position.x, val1.pose_stamped.pose.position.y, val1.pose_stamped.pose.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 32
        (val1.pose_stamped.pose.orientation.x, val1.pose_stamped.pose.orientation.y, val1.pose_stamped.pose.orientation.z, val1.pose_stamped.pose.orientation.w,) = struct.unpack('<4d',str[start:end])
        #deserialize val1.link_names
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.link_names = []
        for i in xrange(0, length):
          start = end
          end += 4
          (length,) = struct.unpack('<I',str[start:end])
          #deserialize val2
          pattern = '<%ss'%length
          start = end
          end += struct.calcsize(pattern)
          (val2,) = struct.unpack(pattern, str[start:end])
          val1.link_names.append(val2)
        start = end
        end += 8
        (val1.penetration_depth,) = struct.unpack('<d',str[start:end])
        self.allowed_contacts.append(val1)
      #deserialize self.path_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.path_constraints.joint_constraints.append(val1)
      #deserialize self.path_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.path_constraints.position_constraints.append(val1)
      #deserialize self.path_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.path_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.path_constraints.orientation_constraints.append(val1)
      #deserialize self.goal_constraints.joint_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.joint_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.JointConstraint()
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.joint_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.joint_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 32
        (val1.position, val1.tolerance_above, val1.tolerance_below, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.goal_constraints.joint_constraints.append(val1)
      #deserialize self.goal_constraints.position_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.position_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.PositionConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 24
        (val1.target_point_offset.x, val1.target_point_offset.y, val1.target_point_offset.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 24
        (val1.position.x, val1.position.y, val1.position.z,) = struct.unpack('<3d',str[start:end])
        start = end
        end += 1
        (val1.constraint_region_shape.type,) = struct.unpack('<b',str[start:end])
        #deserialize val1.constraint_region_shape.dimensions
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.dimensions = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        #deserialize val1.constraint_region_shape.triangles
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        pattern = '<%si'%length
        start = end
        end += struct.calcsize(pattern)
        val1.constraint_region_shape.triangles = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
        #deserialize val1.constraint_region_shape.vertices
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        val1.constraint_region_shape.vertices = []
        for i in xrange(0, length):
          val3 = geometry_msgs.msg.Point()
          start = end
          end += 24
          (val3.x, val3.y, val3.z,) = struct.unpack('<3d',str[start:end])
          val1.constraint_region_shape.vertices.append(val3)
        start = end
        end += 32
        (val1.constraint_region_orientation.x, val1.constraint_region_orientation.y, val1.constraint_region_orientation.z, val1.constraint_region_orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 8
        (val1.weight,) = struct.unpack('<d',str[start:end])
        self.goal_constraints.position_constraints.append(val1)
      #deserialize self.goal_constraints.orientation_constraints
      start = end
      end += 4
      (length,) = struct.unpack('<I',str[start:end])
      self.goal_constraints.orientation_constraints = []
      for i in xrange(0, length):
        val1 = motion_planning_msgs.msg.OrientationConstraint()
        start = end
        end += 4
        (val1.header.seq,) = struct.unpack('<I',str[start:end])
        start = end
        end += 8
        (val1.header.stamp.secs, val1.header.stamp.nsecs,) = struct.unpack('<2I',str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.header.frame_id
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.header.frame_id,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = struct.unpack('<I',str[start:end])
        #deserialize val1.link_name
        pattern = '<%ss'%length
        start = end
        end += struct.calcsize(pattern)
        (val1.link_name,) = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (val1.type,) = struct.unpack('<i',str[start:end])
        start = end
        end += 32
        (val1.orientation.x, val1.orientation.y, val1.orientation.z, val1.orientation.w,) = struct.unpack('<4d',str[start:end])
        start = end
        end += 32
        (val1.absolute_roll_tolerance, val1.absolute_pitch_tolerance, val1.absolute_yaw_tolerance, val1.weight,) = struct.unpack('<4d',str[start:end])
        self.goal_constraints.orientation_constraints.append(val1)
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

# autogenerated by genmsg_py from GetStateValidityResponse.msg. Do not edit.
import roslib.message
import struct

import motion_planning_msgs.msg

class GetStateValidityResponse(roslib.message.Message):
  _md5sum = "48fd1d8662be4b18e218b0ea865c93ed"
  _type = "planning_environment_msgs/GetStateValidityResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """


motion_planning_msgs/ArmNavigationErrorCodes error_code

================================================================================
MSG: motion_planning_msgs/ArmNavigationErrorCodes
int32 val

# overall behavior
int32 PLANNING_FAILED=-1
int32 SUCCESS=1
int32 TIMED_OUT=-2

# start state errors
int32 START_STATE_IN_COLLISION=-3
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-4

# goal errors
int32 GOAL_IN_COLLISION=-5
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-6

# robot state
int32 INVALID_ROBOT_STATE=-7
int32 INCOMPLETE_ROBOT_STATE=-8

# planning request errors
int32 INVALID_PLANNER_ID=-9
int32 INVALID_NUM_PLANNING_ATTEMPTS=-10
int32 INVALID_ALLOWED_PLANNING_TIME=-11
int32 INVALID_GROUP_NAME=-12
int32 INVALID_GOAL_JOINT_CONSTRAINTS=-13
int32 INVALID_GOAL_POSITION_CONSTRAINTS=-14
int32 INVALID_GOAL_ORIENTATION_CONSTRAINTS=-15
int32 INVALID_PATH_JOINT_CONSTRAINTS=-16
int32 INVALID_PATH_POSITION_CONSTRAINTS=-17
int32 INVALID_PATH_ORIENTATION_CONSTRAINTS=-18

# state/trajectory monitor errors
int32 INVALID_TRAJECTORY=-19
int32 INVALID_INDEX=-20
int32 JOINT_LIMITS_VIOLATED=-21
int32 PATH_CONSTRAINTS_VIOLATED=-22
int32 COLLISION_CONSTRAINTS_VIOLATED=-23
int32 GOAL_CONSTRAINTS_VIOLATED=-24
int32 JOINTS_NOT_MOVING=-25
int32 TRAJECTORY_CONTROLLER_FAILED=-26

# system errors
int32 FRAME_TRANSFORM_FAILURE=-27
int32 COLLISION_CHECKING_UNAVAILABLE=-28
int32 ROBOT_STATE_STALE=-29
int32 SENSOR_INFO_STALE=-30

# kinematics errors
int32 NO_IK_SOLUTION=-31
int32 INVALID_LINK_NAME=-32
int32 IK_LINK_IN_COLLISION=-33
int32 NO_FK_SOLUTION=-34
int32 KINEMATICS_STATE_IN_COLLISION=-35

# general errors
int32 INVALID_TIMEOUT=-36


"""
  __slots__ = ['error_code']
  _slot_types = ['motion_planning_msgs/ArmNavigationErrorCodes']

  ## Constructor. Any message fields that are implicitly/explicitly
  ## set to None will be assigned a default value. The recommend
  ## use is keyword arguments as this is more robust to future message
  ## changes.  You cannot mix in-order arguments and keyword arguments.
  ##
  ## The available fields are:
  ##   error_code
  ##
  ## @param self: self
  ## @param args: complete set of field values, in .msg order
  ## @param kwds: use keyword arguments corresponding to message field names
  ## to set specific fields. 
  def __init__(self, *args, **kwds):
    if args or kwds:
      super(GetStateValidityResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
    else:
      self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()

  ## internal API method
  def _get_types(self): return self._slot_types

  ## serialize message into buffer
  ## @param buff StringIO: buffer
  def serialize(self, buff):
    try:
      buff.write(struct.pack('<i', self.error_code.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance
  ## @param self: self
  ## @param str str: byte array of serialized message
  def deserialize(self, str):
    try:
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
      end = 0
      start = end
      end += 4
      (self.error_code.val,) = struct.unpack('<i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  ## serialize message with numpy array types into buffer
  ## @param self: self
  ## @param buff StringIO: buffer
  ## @param numpy module: numpy python module
  def serialize_numpy(self, buff, numpy):
    try:
      buff.write(struct.pack('<i', self.error_code.val))
    except struct.error, se: self._check_types(se)
    except TypeError, te: self._check_types(te)

  ## unpack serialized message in str into this message instance using numpy for array types
  ## @param self: self
  ## @param str str: byte array of serialized message
  ## @param numpy module: numpy python module
  def deserialize_numpy(self, str, numpy):
    try:
      if self.error_code is None:
        self.error_code = motion_planning_msgs.msg.ArmNavigationErrorCodes()
      end = 0
      start = end
      end += 4
      (self.error_code.val,) = struct.unpack('<i',str[start:end])
      return self
    except struct.error, e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

class GetStateValidity(roslib.message.ServiceDefinition):
  _type          = 'planning_environment_msgs/GetStateValidity'
  _md5sum = '9533aede4467e0c6e54a0f6c57ae3e01'
  _request_class  = GetStateValidityRequest
  _response_class = GetStateValidityResponse
