/* auto-generated by gensrv_cpp from /opt/ros/boxturtle/stacks/motion_planning_environment/planning_environment_msgs/srv/GetCollisionObjects.srv.  Do not edit! */
#ifndef SRV_PLANNING_ENVIRONMENT_MSGS_GETCOLLISIONOBJECTS_H
#define SRV_PLANNING_ENVIRONMENT_MSGS_GETCOLLISIONOBJECTS_H

#include <string>
#include <cstring>
#include <vector>
#include <map>
#include "ros/message.h"
#include "ros/time.h"

#include "roslib/Header.h"
#include "geometry_msgs/Point32.h"
#include "mapping_msgs/OrientedBoundingBox.h"
#include "mapping_msgs/CollisionMap.h"
#include "mapping_msgs/CollisionObjectOperation.h"
#include "geometry_msgs/Point.h"
#include "geometric_shapes_msgs/Shape.h"
#include "geometry_msgs/Quaternion.h"
#include "geometry_msgs/Pose.h"
#include "mapping_msgs/CollisionObject.h"
#include "mapping_msgs/AttachedCollisionObject.h"

namespace planning_environment_msgs
{

struct GetCollisionObjects
{

inline static std::string getDataType() { return "planning_environment_msgs/GetCollisionObjects"; }
inline static std::string getMD5Sum() { return "52e374308dcfa795e0a319af5ada16c0"; }

//! \htmlinclude Request.msg.html

class Request : public ros::Message
{
public:
  typedef boost::shared_ptr<Request> Ptr;
  typedef boost::shared_ptr<Request const> ConstPtr;

  typedef uint8_t _include_points_type;

  uint8_t include_points;

  Request() : ros::Message(),
    include_points(0)
  {
  }
  Request(const Request &copy) : ros::Message(),
    include_points(copy.include_points)
  {
    (void)copy;
  }
  Request &operator =(const Request &copy)
  {
    if (this == &copy)
      return *this;
    include_points = copy.include_points;
    return *this;
  }
  virtual ~Request() 
  {
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetCollisionObjectsRequest"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#Whether or not to include the points in the collision map\n"
    "#if set to false, collision map in feedback will contain\n"
    "#no points\n"
    "bool include_points\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("52e374308dcfa795e0a319af5ada16c0"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetCollisionObjects"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += 1; // include_points
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    SROS_SERIALIZE_PRIMITIVE(write_ptr, include_points);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, include_points);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Request> RequestPtr;
typedef boost::shared_ptr<Request const> RequestConstPtr;

//! \htmlinclude Response.msg.html

class Response : public ros::Message
{
public:
  typedef boost::shared_ptr<Response> Ptr;
  typedef boost::shared_ptr<Response const> ConstPtr;

  typedef mapping_msgs::CollisionMap _points_type;
  typedef std::vector<mapping_msgs::CollisionObject> _collision_objects_type;
  typedef std::vector<mapping_msgs::AttachedCollisionObject> _attached_collision_objects_type;

  mapping_msgs::CollisionMap points;
  std::vector<mapping_msgs::CollisionObject> collision_objects;
  std::vector<mapping_msgs::AttachedCollisionObject> attached_collision_objects;

  Response() : ros::Message()
  {
  }
  Response(const Response &copy) : ros::Message(),
    points(copy.points)
  {
    (void)copy;
    collision_objects = copy.collision_objects;
    attached_collision_objects = copy.attached_collision_objects;
  }
  Response &operator =(const Response &copy)
  {
    if (this == &copy)
      return *this;
    collision_objects.clear();
    attached_collision_objects.clear();
    points = copy.points;
    collision_objects = copy.collision_objects;
    attached_collision_objects = copy.attached_collision_objects;
    return *this;
  }
  virtual ~Response() 
  {
    collision_objects.clear();
    attached_collision_objects.clear();
  }
  inline static std::string __s_getDataType() { return std::string("planning_environment_msgs/GetCollisionObjectsResponse"); }
  inline static std::string __s_getMD5Sum() { return std::string(""); }
  inline static std::string __s_getMessageDefinition()
  {
    return std::string(
    "#points in the collision map if include_points is set to true\n"
    "mapping_msgs/CollisionMap points\n"
    "#vector of collision objects in the collision map\n"
    "mapping_msgs/CollisionObject[] collision_objects\n"
    "#vector of attached collision objects in the collision map\n"
    "mapping_msgs/AttachedCollisionObject[] attached_collision_objects\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/CollisionMap\n"
    "#header for interpreting box positions\n"
    "Header header\n"
    "\n"
    "#boxes for use in collision testing\n"
    "OrientedBoundingBox[] boxes\n"
    "\n"
    "================================================================================\n"
    "MSG: roslib/Header\n"
    "# Standard metadata for higher-level stamped data types.\n"
    "# This is generally used to communicate timestamped data \n"
    "# in a particular coordinate frame.\n"
    "# \n"
    "# sequence ID: consecutively increasing ID \n"
    "uint32 seq\n"
    "#Two-integer timestamp that is expressed as:\n"
    "# * stamp.secs: seconds (stamp_secs) since epoch\n"
    "# * stamp.nsecs: nanoseconds since stamp_secs\n"
    "# time-handling sugar is provided by the client library\n"
    "time stamp\n"
    "#Frame this data is associated with\n"
    "# 0: no frame\n"
    "# 1: global frame\n"
    "string frame_id\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/OrientedBoundingBox\n"
    "#the center of the box\n"
    "geometry_msgs/Point32 center\n"
    "\n"
    "#the extents of the box, assuming the center is at the point\n"
    "geometry_msgs/Point32 extents\n"
    "\n"
    "#the axis of the box\n"
    "geometry_msgs/Point32 axis\n"
    "\n"
    "#the angle of rotation around the axis\n"
    "float32 angle\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point32\n"
    "# This contains the position of a point in free space(with 32 bits of precision).\n"
    "# It is recommeded to use Point wherever possible instead of Point32.  \n"
    "# \n"
    "# This recommendation is to promote interoperability.  \n"
    "#\n"
    "# This message is designed to take up less space when sending\n"
    "# lots of points at once, as in the case of a PointCloud.  \n"
    "\n"
    "float32 x\n"
    "float32 y\n"
    "float32 z\n"
    "================================================================================\n"
    "MSG: mapping_msgs/CollisionObject\n"
    "# a header, used for interpreting the poses\n"
    "Header header\n"
    "\n"
    "# the id of the object\n"
    "string id\n"
    "\n"
    "#This contains what is to be done with the object\n"
    "CollisionObjectOperation operation\n"
    "\n"
    "#the shapes associated with the object\n"
    "geometric_shapes_msgs/Shape[] shapes\n"
    "\n"
    "#the poses associated with the shapes - will be transformed using the header\n"
    "geometry_msgs/Pose[] poses\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/CollisionObjectOperation\n"
    "#Puts the object into the environment\n"
    "#or updates the object if already added\n"
    "byte ADD=0\n"
    "\n"
    "#Removes the object from the environment entirely\n"
    "byte REMOVE=1\n"
    "\n"
    "#Only valid within the context of a CollisionAttachedObject message\n"
    "#Will be ignored if sent with an CollisionObject message\n"
    "#Takes an attached object, detaches from the attached link\n"
    "#But adds back in as regular object\n"
    "byte DETACH_AND_ADD_AS_OBJECT=2\n"
    "\n"
    "#Only valid within the context of a CollisionAttachedObject message\n"
    "#Will be ignored if sent with an CollisionObject message\n"
    "#Takes current object in the environment and removes it as\n"
    "#a regular object\n"
    "byte ATTACH_AND_REMOVE_AS_OBJECT=3\n"
    "\n"
    "# Byte code for operation\n"
    "byte operation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometric_shapes_msgs/Shape\n"
    "byte SPHERE=0\n"
    "byte BOX=1\n"
    "byte CYLINDER=2\n"
    "byte MESH=3\n"
    "\n"
    "byte type\n"
    "\n"
    "\n"
    "#### define sphere, box, cylinder ####\n"
    "# the origin of each shape is considered at the shape's center\n"
    "\n"
    "# for sphere\n"
    "# radius := dimensions[0]\n"
    "\n"
    "# for cylinder\n"
    "# radius := dimensions[0]\n"
    "# length := dimensions[1]\n"
    "# the length is along the Z axis\n"
    "\n"
    "# for box\n"
    "# size_x := dimensions[0]\n"
    "# size_y := dimensions[1]\n"
    "# size_z := dimensions[2]\n"
    "float64[] dimensions\n"
    "\n"
    "\n"
    "#### define mesh ####\n"
    "\n"
    "# list of triangles; triangle k is defined by tre vertices located\n"
    "# at indices triangles[3k], triangles[3k+1], triangles[3k+2]\n"
    "int32[] triangles\n"
    "geometry_msgs/Point[] vertices\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Point\n"
    "# This contains the position of a point in free space\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Pose\n"
    "# A representation of pose in free space, composed of postion and orientation. \n"
    "Point position\n"
    "Quaternion orientation\n"
    "\n"
    "================================================================================\n"
    "MSG: geometry_msgs/Quaternion\n"
    "# This represents an orientation in free space in quaternion form.\n"
    "\n"
    "float64 x\n"
    "float64 y\n"
    "float64 z\n"
    "float64 w\n"
    "\n"
    "================================================================================\n"
    "MSG: mapping_msgs/AttachedCollisionObject\n"
    "# The CollisionObject will be attached with a fixed joint to this link\n"
    "# If link name is set to REMOVE_ALL_ATTACHED_OBJECTS and object.operation \n"
    "# is set to REMOVE will remove all attached bodies attached to any object\n"
    "string link_name\n"
    "\n"
    "#Reserved for indicating that all attached objects should be removed\n"
    "string REMOVE_ALL_ATTACHED_OBJECTS = \"all\"\n"
    "\n"
    "#This contains the actual shapes and poses for the CollisionObject\n"
    "#to be attached to the link\n"
    "#If action is remove and no object.id is set, all objects\n"
    "#attached to the link indicated by link_name will be removed\n"
    "CollisionObject object\n"
    "\n"
    "# The set of links that the attached objects are allowed to touch\n"
    "# by default - the link_name is included by default\n"
    "string[] touch_links\n"
    "\n"
    "\n"
    );
  }
  inline virtual const std::string __getDataType() const { return __s_getDataType(); }
  inline virtual const std::string __getMD5Sum() const { return __s_getMD5Sum(); }
  inline virtual const std::string __getMessageDefinition() const { return __s_getMessageDefinition(); }
  inline static std::string __s_getServerMD5Sum() { return std::string("52e374308dcfa795e0a319af5ada16c0"); }
  inline virtual const std::string __getServerMD5Sum() const { return __s_getServerMD5Sum(); }
  inline static std::string __s_getServiceDataType() { return std::string("planning_environment_msgs/GetCollisionObjects"); }
  inline virtual const std::string __getServiceDataType() const { return __s_getServiceDataType(); }
  void set_collision_objects_size(uint32_t __ros_new_size)
  {
    this->collision_objects.resize(__ros_new_size);
  }
  inline uint32_t get_collision_objects_size() const { return collision_objects.size(); }
  uint32_t calc_collision_objects_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t collision_objects_size = collision_objects.size();
    for (size_t i = 0; i < collision_objects_size; i++)
      l += collision_objects[i].serializationLength();
    return l;
  }
  inline void get_collision_objects_vec (std::vector<mapping_msgs::CollisionObject> &__ros_vec) const
  {
    __ros_vec = this->collision_objects;
  }
  inline void set_collision_objects_vec(const std::vector<mapping_msgs::CollisionObject> &__ros_vec)
  {
    this->collision_objects = __ros_vec;
  }
  void set_attached_collision_objects_size(uint32_t __ros_new_size)
  {
    this->attached_collision_objects.resize(__ros_new_size);
  }
  inline uint32_t get_attached_collision_objects_size() const { return attached_collision_objects.size(); }
  uint32_t calc_attached_collision_objects_array_serialization_len() const
  {
    uint32_t l = 0;
    uint32_t attached_collision_objects_size = attached_collision_objects.size();
    for (size_t i = 0; i < attached_collision_objects_size; i++)
      l += attached_collision_objects[i].serializationLength();
    return l;
  }
  inline void get_attached_collision_objects_vec (std::vector<mapping_msgs::AttachedCollisionObject> &__ros_vec) const
  {
    __ros_vec = this->attached_collision_objects;
  }
  inline void set_attached_collision_objects_vec(const std::vector<mapping_msgs::AttachedCollisionObject> &__ros_vec)
  {
    this->attached_collision_objects = __ros_vec;
  }
  inline uint32_t serializationLength() const
  {
    unsigned __l = 0;
    __l += points.serializationLength(); // points
    __l += 4 + calc_collision_objects_array_serialization_len(); // collision_objects
    __l += 4 + calc_attached_collision_objects_array_serialization_len(); // attached_collision_objects
    return __l;
  }
  virtual uint8_t *serialize(uint8_t *write_ptr,
#if defined(__GNUC__)
                             __attribute__((unused)) uint32_t seq) const
#else
                             uint32_t seq) const
#endif
  {
    write_ptr = points.serialize(write_ptr, seq);
    uint32_t __collision_objects_size = collision_objects.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __collision_objects_size);
    for (size_t i = 0; i < __collision_objects_size; i++)
      write_ptr = collision_objects[i].serialize(write_ptr, seq);
    uint32_t __attached_collision_objects_size = attached_collision_objects.size();
    SROS_SERIALIZE_PRIMITIVE(write_ptr, __attached_collision_objects_size);
    for (size_t i = 0; i < __attached_collision_objects_size; i++)
      write_ptr = attached_collision_objects[i].serialize(write_ptr, seq);
    return write_ptr;
  }
  virtual uint8_t *deserialize(uint8_t *read_ptr)
  {
    read_ptr = points.deserialize(read_ptr);
    uint32_t __collision_objects_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __collision_objects_size);
    set_collision_objects_size(__collision_objects_size);
    for (size_t i = 0; i < __collision_objects_size; i++)
      read_ptr = collision_objects[i].deserialize(read_ptr);
    uint32_t __attached_collision_objects_size;
    SROS_DESERIALIZE_PRIMITIVE(read_ptr, __attached_collision_objects_size);
    set_attached_collision_objects_size(__attached_collision_objects_size);
    for (size_t i = 0; i < __attached_collision_objects_size; i++)
      read_ptr = attached_collision_objects[i].deserialize(read_ptr);
    return read_ptr;
  }
};

typedef boost::shared_ptr<Response> ResponsePtr;
typedef boost::shared_ptr<Response const> ResponseConstPtr;

Request request;
Response response;

};

}

#endif
